commit 7ac22b338a194851c9a801cd710f7eddb145c087
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Tue May 23 10:16:22 2017 -0500

    Log: various: fix spelling in messages and comments

Index: pacemaker-1.1.16+20170320.77ea74d/crmd/control.c
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/crmd/control.c
+++ pacemaker-1.1.16+20170320.77ea74d/crmd/control.c
@@ -184,7 +184,7 @@ do_shutdown(long long action,
         if (is_set(fsa_input_register, pe_subsystem->flag_connected)) {
             crm_info("Terminating the %s", pe_subsystem->name);
             if (stop_subsystem(pe_subsystem, TRUE) == FALSE) {
-                /* its gone... */
+                /* It's gone ... */
                 crm_err("Faking %s exit", pe_subsystem->name);
                 clear_bit(fsa_input_register, pe_subsystem->flag_connected);
             } else {
@@ -590,12 +590,12 @@ do_startup(long long action,
         finalization_timer->callback = crm_timer_popped;
         finalization_timer->repeat = FALSE;
         /* for possible enabling... a bug in the join protocol left
-         *    a slave in S_PENDING while we think its in S_NOT_DC
+         *    a slave in S_PENDING while we think it's in S_NOT_DC
          *
          * raising I_FINALIZED put us into a transition loop which is
          *    never resolved.
          * in this loop we continually send probes which the node
-         *    NACK's because its in S_PENDING
+         *    NACK's because it's in S_PENDING
          *
          * if we have nodes where heartbeat is active but the
          *    CRM is not... then this will be handled in the
Index: pacemaker-1.1.16+20170320.77ea74d/crmd/fsa_defines.h
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/crmd/fsa_defines.h
+++ pacemaker-1.1.16+20170320.77ea74d/crmd/fsa_defines.h
@@ -93,7 +93,7 @@ Description:
       The election algorithm has been adapted from
       http://www.cs.indiana.edu/cgi-bin/techreports/TRNNN.cgi?trnum=TR521
 
-      Loosly known as the Bully Algorithm, its major points are:
+      Loosely known as the Bully Algorithm, its major points are:
       - Election is initiated by any node (N) notices that the controller
 	is no longer responding
       - Concurrent multiple elections are possible
Index: pacemaker-1.1.16+20170320.77ea74d/cts/CM_lha.py
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/cts/CM_lha.py
+++ pacemaker-1.1.16+20170320.77ea74d/cts/CM_lha.py
@@ -149,7 +149,7 @@ class crm_lha(ClusterManager):
 
         self.ShouldBeStatus[node] = "up"
 
-        # check the output first - because syslog-ng looses messages
+        # check the output first - because syslog-ng loses messages
         if string.find(out, 'S_NOT_DC') != -1:
             # Up and stable
             return 2
Index: pacemaker-1.1.16+20170320.77ea74d/include/crm/cluster/internal.h
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/include/crm/cluster/internal.h
+++ pacemaker-1.1.16+20170320.77ea74d/include/crm/cluster/internal.h
@@ -76,10 +76,9 @@ struct crm_ais_quorum_resp_s {
 /* *INDENT-OFF* */
 enum crm_proc_flag {
     crm_proc_none      = 0x00000001,
-    /* These values are sent over the network by the legacy plugin
-     * Therefor changing any of these values is going to break compatibility
-     *
-     * So don't
+    /* @COMPAT These values are sent over the network by the legacy plugin.
+     * Therefore, changing any of these values is going to break compatibility.
+     * So don't.
      */
 
     /* 3 messaging types */
Index: pacemaker-1.1.16+20170320.77ea74d/include/crm/common/xml.h
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/include/crm/common/xml.h
+++ pacemaker-1.1.16+20170320.77ea74d/include/crm/common/xml.h
@@ -242,7 +242,7 @@ gboolean validate_xml(xmlNode * xml_blob
 gboolean validate_xml_verbose(xmlNode * xml_blob);
 
 /*!
- * \brief Try update CIB XML to the highest pacemaker's standard if feasible
+ * \brief Update CIB XML to most recent schema version
  *
  * "Update" means either actively employ XSLT-based transformation(s)
  * (if intermediate product to transform valid per its declared schema version,
Index: pacemaker-1.1.16+20170320.77ea74d/include/crm/msg_xml.h
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/include/crm/msg_xml.h
+++ pacemaker-1.1.16+20170320.77ea74d/include/crm/msg_xml.h
@@ -241,6 +241,8 @@
 #  define XML_LRM_TAG_RSC_OP		"lrm_rsc_op"
 #  define XML_AGENT_ATTR_CLASS		"class"
 #  define XML_AGENT_ATTR_PROVIDER	"provider"
+
+/* @COMPAT This was never used but is kept for API compatibility */
 #  define XML_LRM_TAG_ATTRIBUTES	"attributes"
 
 #  define XML_CIB_ATTR_REPLACE       	"replace"
Index: pacemaker-1.1.16+20170320.77ea74d/lib/ais/plugin.c
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/lib/ais/plugin.c
+++ pacemaker-1.1.16+20170320.77ea74d/lib/ais/plugin.c
@@ -629,7 +629,7 @@ pcmk_startup(struct corosync_api_v1 *ini
         }
 #if 0
         /* system() is not thread-safe, can't call from here
-         * Actually, its a pretty hacky way to try and achieve this anyway
+         * Actually, it's a pretty hacky way to try and achieve this anyway
          */
         if (system("echo 1 > /proc/sys/kernel/core_uses_pid") != 0) {
             ais_perror("Could not enable /proc/sys/kernel/core_uses_pid");
@@ -1144,7 +1144,7 @@ pcmk_shutdown(void)
 
     send_cluster_id();
     ais_notice("Shutdown complete");
-    /* TODO: Add back the logsys flush call once its written */
+    /* TODO: Add back the logsys flush call once it's written */
 
     return 0;
 }
Index: pacemaker-1.1.16+20170320.77ea74d/lib/cluster/heartbeat.c
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/lib/cluster/heartbeat.c
+++ pacemaker-1.1.16+20170320.77ea74d/lib/cluster/heartbeat.c
@@ -267,7 +267,7 @@ convert_xml_child(HA_Message * msg, xmlN
         goto done;
     }
 
-    len = (orig * 1.1) + 600;   /* recomended size */
+    len = (orig * 1.1) + 600;   /* recommended size */
 
     compressed = malloc(len);
     rc = BZ2_bzBuffToBuffCompress(compressed, &len, buffer, orig, CRM_BZ2_BLOCKS, 0, CRM_BZ2_WORK);
Index: pacemaker-1.1.16+20170320.77ea74d/lib/common/strings.c
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/lib/common/strings.c
+++ pacemaker-1.1.16+20170320.77ea74d/lib/common/strings.c
@@ -317,7 +317,7 @@ crm_compress_string(const char *data, in
     struct timespec before_t;
 
     if(max == 0) {
-        max = (length * 1.1) + 600; /* recomended size */
+        max = (length * 1.1) + 600; /* recommended size */
     }
 
 #ifdef CLOCK_MONOTONIC
Index: pacemaker-1.1.16+20170320.77ea74d/lib/pengine/utils.c
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/lib/pengine/utils.c
+++ pacemaker-1.1.16+20170320.77ea74d/lib/pengine/utils.c
@@ -1367,7 +1367,7 @@ sort_op_by_callid(gconstpointer a, gcons
         /* We have duplicate lrm_rsc_op entries in the status
          *    section which is unliklely to be a good thing
          *    - we can handle it easily enough, but we need to get
-         *    to the bottom of why its happening.
+         *    to the bottom of why it's happening.
          */
         pe_err("Duplicate lrm_rsc_op entries named %s", a_xml_id);
         sort_return(0, "duplicate");
@@ -1431,7 +1431,7 @@ sort_op_by_callid(gconstpointer a, gcons
          * some pending operations (ie. a start) may have been superseded
          *   by a subsequent stop
          *
-         * [a|b]_id == -1 means its a shutdown operation and _always_ comes last
+         * [a|b]_id == -1 means it's a shutdown operation and _always_ comes last
          */
         if (safe_str_neq(a_uuid, b_uuid) || a_id == b_id) {
             /*
@@ -1531,7 +1531,7 @@ order_actions(action_t * lh_action, acti
 
     crm_trace("Ordering Action %s before %s", lh_action->uuid, rh_action->uuid);
 
-    /* Ensure we never create a dependency on ourselves... its happened */
+    /* Ensure we never create a dependency on ourselves... it's happened */
     CRM_ASSERT(lh_action != rh_action);
 
     /* Filter dups, otherwise update_action_states() has too much work to do */
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/utilization.c
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/pengine/utilization.c
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/utilization.c
@@ -152,7 +152,7 @@ check_capacity(gpointer key, gpointer va
         CRM_ASSERT(data->rsc_id);
         CRM_ASSERT(data->node);
 
-        crm_debug("Node %s has no enough %s for %s: required=%d remaining=%d",
+        crm_debug("Node %s does not have enough %s for %s: required=%d remaining=%d",
                   data->node->details->uname, (char *)key, data->rsc_id, required, remaining);
         data->is_enough = FALSE;
     }
@@ -382,7 +382,9 @@ process_utilization(resource_t * rsc, no
                     }
 
                     if (have_enough_capacity(node, rscs_id, unallocated_utilization) == FALSE) {
-                        pe_rsc_debug(rsc, "Resource %s and its colocated resources cannot be allocated to node %s: no enough capacity",
+                        pe_rsc_debug(rsc,
+                                     "Resource %s and its colocated resources"
+                                     " cannot be allocated to node %s: not enough capacity",
                                      rsc->id, node->details->uname);
                         resource_location(rsc, node, -INFINITY, "__limit_utilization__", data_set);
                     }
@@ -408,7 +410,9 @@ process_utilization(resource_t * rsc, no
                 }
 
                 if (have_enough_capacity(node, rsc->id, rsc->utilization) == FALSE) {
-                    pe_rsc_debug(rsc, "Resource %s cannot be allocated to node %s: no enough capacity",
+                    pe_rsc_debug(rsc,
+                                 "Resource %s cannot be allocated to node %s:"
+                                 " not enough capacity",
                                  rsc->id, node->details->uname);
                     resource_location(rsc, node, -INFINITY, "__limit_utilization__", data_set);
                 }